SystemOrganization addCategory: #MSFTM!

Object subclass: #MSFTMUser
	instanceVariableNames: 'name role createdTopics managedTopics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:32'!
addCreatedTopic: aTopic
	"Adiciona um novo tpico a lista de tpicos criados pelo usurio"

	createdTopics add: aTopic.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:40'!
addManagedTopic: aTopic
	"Adiciona um novo tpico a lista de tpicos moderados pelo usurio"

	managedTopics add: aTopic.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:41'!
getCreatedTopics
	"Devolve uma coleo com todos os tpicos criados pelo usurio"

	^createdTopics.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:41'!
getManagedTopics
	"Devolve uma coleo com todos os tpicos moderados pelo usurio"

	^managedTopics.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:13'!
initialize
	"Realiza a inicializao das variveis de instncia"

	super initialize.
	name := ''.
	role := ''.
	createdTopics := Set new. 
	managedTopics := Set new.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:52'!
matchesByName: aString
	"Devolve true se o usurio tem o determinado nome"

	^ aString match: name.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:17'!
name
	"Devolve o nome do usurio"

	^name.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:17'!
name: aString
	"Define o nome do usurio"

	name := aString.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:24'!
role
	"Devolve o privilgio do usurio"

	^ role.! !

!MSFTMUser methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:24'!
role: aString
	"Define o privilgio do usurio"

	role := aString.! !

Object subclass: #MSFTMUserManager
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!MSFTMUserManager methodsFor: 'as yet unclassified' stamp: 'has 5/29/2013 00:02'!
createUser: userName ofRole: userRole
	"Cria um novo usurio e o adiciona na lista de usurios"

	| user |
	
	user := MSFTMUser new.
	user name: userName.
	user role: userRole.
	users add: user.
	^ user.! !

!MSFTMUserManager methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:57'!
findUserByName: aName
	"Devolve um usurio com determinado nome"
	
	^ users select: [ :user | user matchesByName: aName ].! !

!MSFTMUserManager methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:06'!
getAllUsers
	"Devolve uma coleo com todos os usurios cadastrados"

	^ users.
	! !

!MSFTMUserManager methodsFor: 'as yet unclassified' stamp: 'RW 5/15/2013 09:08'!
initialize
	"Realiza a inicializao das variveis de instncia"
	super initialize.
	users := Set new.! !

Object subclass: #RoleManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!RoleManager methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:26'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.! !

Object subclass: #Topic
	instanceVariableNames: 'owner managers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

Topic subclass: #Discipline
	instanceVariableNames: 'acronym chiefInstructor groups courses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:53'!
acronym
	"Devolve o acrnimo da disciplina"
	
	^ acronym.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:53'!
acronym: aString
	"Define o acrnimo da disciplina"
	
	acronym := aString.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:57'!
addCourse: aCourse
	"Adiciona curso  disciplina"
	
	courses add: aCourse.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:56'!
addGroup: aGroup
	"Adiciona grupo  disciplina"
	
	groups add: aGroup.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:01'!
chiefInstructor
	"Devolve o chefe da disciplina"
	
	^ chiefInstructor.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:01'!
chiefInstructor: aChiefInstructor
	"Define o chefe da disciplina"
	
	chiefInstructor := aChiefInstructor.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:19'!
getAllCourses
	"Devolve a lista de todos os cursos que contm essa disciplina"
	
	^ courses.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:22'!
getAllGroups
	"Devolve a lista de todas as turmas dessa disciplina"
	
	^ groups.! !

!Discipline methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:52'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.
	acronym := ''.
	chiefInstructor := nil.
	groups := Set new.
	courses := Set new.! !

Topic subclass: #Lesson
	instanceVariableNames: 'description materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!Lesson methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:38'!
description
	"Devolve a descrio de uma aula"
	
	^description.! !

!Lesson methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:38'!
description: aString
	"Define a descrio de uma aula"
	
	description := aString.! !

!Lesson methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:41'!
getAllMaterials
	"Devolve os materiais da aula"
	
	^materials.! !

!Lesson methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:21'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.
	description := ''.
	materials := Set new.! !

Topic subclass: #MSFTMCourse
	instanceVariableNames: 'name category disciplines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:49'!
addDiscipline: discipline
	"Adiciona uma disciplina ao curso"
	
	disciplines add: discipline.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:44'!
category
	"Devolve a categoria do curso"

	^category.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:44'!
category: aString
	"Define a categoria do curso"

	category := aString.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:16'!
getAllDisciplines
	"Devolve a lista de todas as disciplinas desse curso"
	
	^ disciplines.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:29'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.
	name := ''.
	category := ''.
	disciplines := Set new.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:43'!
name
	"Devolve o nome do curso"

	^name.! !

!MSFTMCourse methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:44'!
name: aString
	"Define o nome do curso"

	name := aString.! !

Topic subclass: #MSFTMGroup
	instanceVariableNames: 'code instructor year semester lessons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:26'!
code
	"Devolve o cdigo da turma"
	
	^ code.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:27'!
code: aString
	"Define o cdigo da turma"
	
	code := aString.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:33'!
getAllLessons
	"Devolve a lista de todos as aulas de uma Turma"
	
	^ lessons.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:20'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.
	code := ''.
	instructor := nil.
	year := 0. 
	semester := 0.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:29'!
instructor: user
	"Devole o instrutor da turma"
	
	^ instructor.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:28'!
semester
	"Devolve o semestre da turma"
	
	^ semester.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:28'!
semester: aString
	"Define o semestre da turma"
	
	semester := aString.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:27'!
year
	"Devolve o ano da turma"
	
	^ year.! !

!MSFTMGroup methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:27'!
year: aString
	"Define o ano da turma"
	
	year := aString.! !

Topic subclass: #TeachingMaterial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!TeachingMaterial methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:29'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.! !

!Topic methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:30'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.
	owner := nil.
	managers := Set new.! !

!Topic methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:12'!
owner
	"Devolve o dono do tpico."
	
	^ owner.! !

!Topic methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:12'!
owner: aOwner
	"Define o dono do tpico."
	
	owner := aOwner.! !

Object subclass: #TopicManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSFTM'!

!TopicManager methodsFor: 'as yet unclassified' stamp: 'oda 6/24/2013 21:56'!
createCourse: courseName ofCategory: courseCategory owner: courseOwner
	"Criador de curso"

	| course |
	course := MSFTMCourse new.
	course name: courseName.
	course category: courseCategory.
	course owner: courseOwner.
	^ course.! !

!TopicManager methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 18:20'!
createDiscipline: disciplineAcronym ofChiefInstructor: disciplineChiefInstructor ofCourse: disciplineCourse owner: disciplineOwner
	"Criador de disciplina"

	| discipline |
	discipline := Discipline new.
	discipline acronym: disciplineAcronym.
	discipline chiefInstructor: disciplineChiefInstructor.
	discipline addCourse: disciplineCourse.
	discipline owner: disciplineOwner.
	^ discipline.! !

!TopicManager methodsFor: 'as yet unclassified' stamp: 'oda 6/24/2013 21:56'!
createGroup: groupCode ofInstructor: groupInstructor ofYear: groupYear ofSemester: groupSemester owner: groupOwner
	"Criador de aula"

	| group |
	
	group := MSFTMGroup new.
	group code: groupCode.
	group instructor: groupInstructor.
	group year: groupYear.
	group semester: groupSemester.
	group owner: groupOwner.
	
	^ group.! !

!TopicManager methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 17:37'!
createLesson: lessonDescription
	"Criador de aula"
	| lesson |
	lesson := Lesson new.
	lesson description: lessonDescription.
	^ lesson.! !

!TopicManager methodsFor: 'as yet unclassified' stamp: 'RAL 5/15/2013 16:30'!
initialize
	"Realiza a inicializao das variveis de instncia"
	
	super initialize.! !
